<template>
    <div class="w-10 flex flex-column h-auto m-auto">
        <h5 class="text-lg text-white-alpha-90">New profil picture</h5>
        <FileUpload v-model="picture" accept="image/*" :previewWidth="200" :showUploadButton="false" :maxFileSize="1048576" :showCancelButton="false" :showChooseButton="false" @select="selectPic">
            <template #empty>
                <p>Drag and drop your image here</p>
            </template>
        </FileUpload>
        <Button class="mt-5" label="Change profil picture" @click="changePicture"></Button>
    </div>
</template>

<script>
import Button from 'primevue/button';
import FileUpload from 'primevue/fileupload';
import { createToast } from "mosha-vue-toastify";

export default {
    name: 'changeUsername',
    picBlob: null,
    data() {
        return {
            picture: null,
        }
    },
    components: {
        Button,
        FileUpload
    },
    methods: {
        changePicture() {
            if(this.picture && this.userId){
                let formData = new FormData();
                formData.append('file', this.picture);
                fetch('http://localhost:3000/api/upload-pp/' + this.userId, {
                    method: 'POST',
                    headers: {
                        'Authorization': 'Bearer ' + localStorage.getItem('token')
                    },
                    body: formData
                })
                .then(response => response.json())
                .then(res => {
                    if(res.status && res.status == 200){
                        this.getPicBlob(res.message);
                    } else {
                        this.toast('Error while changing picture', 'error');
                    }
                })
            }
        },
        selectPic(e) {
            this.picture = e.files[0];
        },
        getPicBlob(pic) {
            console.log(pic);
            fetch(`http://localhost:3000/files/${pic}`)
            .then(res => res.blob())
            .then(pict => {
                document.querySelector(".pp").remove();
                let blobPath = URL.createObjectURL(pict);
                let div = document.createElement("div");
                div.className = "pp";
                div.style.backgroundImage = `url(${blobPath})`;
                document.querySelector(".thePicture").appendChild(div);
                this.toast("Picture changed successfully", "success");
            })
        },
    },
    computed: {
        userId() {
            return this.$store.state.userData.id;
        }
    },
    mounted() {
        // console.log(this.userId);
    },
    setup() {
    const toast = (message, type) => {
      createToast(message, {
        position: "top-right",
        timeout: 5000,
        type: type,
        showIcon: true,
      });
    };
    return { toast };
    
  },
}
</script>

<style scoped>

.p-fileupload-filename {
    display: none !important;
}

</style>